<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>

    <script src="https://code.jquery.com/jquery-2.2.4.min.js"></script>
    <script type="text/javascript">

        var socket;

        function sock_open() {
            var text = document.getElementById('txtip');
            var msg = text.value;
            socket = new WebSocket("ws://"+msg+"/ws");
            socket.onopen = sockopen;
            socket.onclose = sockclose;
            socket.onmessage = sockmsg;
            socket.onerror = sockerr;
        }

        function div_alert(text) {
            var d = new Date();
            var dl = new Date(d.getTime()+d.getTimezoneOffset()*60*1000);
            var doffs = d.getTimezoneOffset() / 60;
            var dhours = d.getHours();
            dl.setHours(dhours - doffs);
            var dt = dl.toJSON().replace('T',' ').replace('Z','');
            $("<div style='border-bottom:1px solid blue'>"+dt+" == "+text+"</div>").prependTo("#alert");
        }

        function sockopen() { div_alert("open"); send('["open",{}]'); }
        function sockclose(event) { if (event.wasClean) div_alert("close clean"); else div_alert("close break" + " " + event.code + " " + event.reason); }
        function sockmsg(event) {
            div_alert("message: " + event.data.toString());
            var D = JSON.parse(event.data);
            if ((D[0]=="activate_session") ||
                (D[0]=="reactivate_session") ||
                (D[0]=="kill_session") ||
                (D[0]=="session_msg") ||
                (D[0]=="session_event")) {
                send('["activate_session_result",{"qid":"' + D[1]["qid"] + '","result":"ok"}]');
                div_alert("response sent: " + '["activate_session_result",{"qid":"' + D[1]["qid"] + '","result":"ok"}]');
            }
        }
        function sockerr(error) { div_alert("error: " + error.message.toString()); }
        function send(msg) { socket.send(msg); }

        //--------------------------------------------------------------------------------------------
        function send_err1() { send('asdf'); }
        function send_err2() { send('["asdf",[1,2,3]]'); }
        function send_err3() { send('["asdf",{"qid":'+Math.random()+',"a":0},{"zzz":5}]'); }
        function send_err4() { send('["asdf",{"qid":'+Math.random()+',"a":0}]'); }

        function send_test() { send('["test",{"qid":'+Math.random()+'}]'); }

        function send_auth1() { send('["authenticate",{"qid":'+Math.random()+'}]'); }
        function send_auth2() { send('["authenticate",{"qid":'+Math.random()+',"login":"admin","pwd":"admin","td":"root"}]'); }
        function send_auth3() {
            var text = document.getElementById('txtsess');
            var msg = text.value;
            send('["authenticate",{"qid":'+Math.random()+',"session":"' + msg + '"}]'); }

        function send_stop() { send('["stop",{"qid":'+Math.random()+'}]'); }

        function send_setup() { send('["setup",{"qid":'+Math.random()+', "capabilities":[{"key":"rest"},{"key":"subscr"},{"key":"sample"},{"key":"scripteditor"},{"key":"test"}]}]'); }

        //--------------------------------------------------------------------------------------------
        function send_subscribe() { send('["subscribe",{"qid":'+Math.random()+', "objects":"any", "events":["infinity-x.*","ivrevents.api_start","ivrevents.api_stop"], "expires":7200, "id":"asdf_infinity"}]'); }
        function send_subscribe_mnesia() { send('["subscribe",{"qid":'+Math.random()+', "objects":["abc/mnesia"], "events":["modelevents.data_changed"], "expires":7200, "id":"abc/mnesia_model"}]'); }
        function send_subscribe_abcdef() { send('["subscribe",{"qid":'+Math.random()+', "objects":["abc/def"], "events":["modelevents.data_changed"], "expires":7200, "id":"abcdef2_model"}]'); }
        function send_subscribe_abcdef_f() { send('["subscribe",{"qid":'+Math.random()+', "objects":["abc/def"], "events":["modelevents.data_changed"], "exargs":{"filter":["like",["property","pstr"],"123*"],"mask":"id,name"}, "expires":7200, "id":"abcdef3_model"}]'); }
        function send_subscribe_abcets_f() { send('["subscribe",{"qid":'+Math.random()+', "objects":["abc/ets"], "events":["modelevents.data_changed"], "exargs":{"filter":["like",["property","pstr"],"123*"],"mask":"id,name"}, "expires":7200, "id":"abcets_model"}]'); }
        function send_subscribe_kafka() { send('["subscribe",{"qid":'+Math.random()+', "objects":["abc/kafka"], "events":["modelevents.data_changed"], "expires":7200, "id":"asdf_model_kafka"}]'); }

        function send_cr_up() {
            send('["rest",{"qid":1,"operation":"replace", "classpath":"/rest/v1/model/abc/mnesia", "id":"10101010-1010-1010-1010-101010101010", "content":{"pint":500,"pstr":"1"} }]');
            send('["rest",{"qid":2,"operation":"update", "classpath":"/rest/v1/model/abc/mnesia", "id":"10101010-1010-1010-1010-101010101010", "content":{"pint":800,"pstr":"2"} }]'); }
        function send_cr_cr() {
            send('["rest",{"qid":3,"operation":"replace", "classpath":"/rest/v1/model/abc/mnesia", "id":"20101010-1010-1010-1010-101010101010", "content":{"pint":500,"pstr":"1"} }]');
            send('["rest",{"qid":4,"operation":"replace", "classpath":"/rest/v1/model/abc/mnesia", "id":"30101010-1010-1010-1010-101010101010", "content":{"pint":800,"pstr":"2"} }]'); }
        function send_del() {
            send('["rest",{"qid":5,"operation":"delete", "classpath":"/rest/v1/model/abc/mnesia", "id":"10101010-1010-1010-1010-101010101010" }]');
            send('["rest",{"qid":6,"operation":"delete", "classpath":"/rest/v1/model/abc/mnesia", "id":"20101010-1010-1010-1010-101010101010" }]');
            send('["rest",{"qid":7,"operation":"delete", "classpath":"/rest/v1/model/abc/mnesia", "id":"30101010-1010-1010-1010-101010101010" }]'); }

        function send_textarea() {
            var text = document.getElementById('txta');
            var msg = text.value;
            send(msg); }

    </script>
</head>

    <body>
        <H1>asdf</H1>
        <br>
        <textarea name="txtip" id="txtip" cols="20" rows="1">192.168.0.112</textarea>
        <input type="button" value="open user" onclick="sock_open()">
        <br><br>
        <input type="button" value="err1" onclick="send_err1()">
        <input type="button" value="err2" onclick="send_err2()">
        <input type="button" value="err3" onclick="send_err3()">
        <input type="button" value="err4" onclick="send_err4()">
        <br><br>
        Session token: <textarea name="txtsess" id="txtsess" cols="60" rows="1"></textarea>
        <br>
        <input type="button" value="test" onclick="send_test()">
        <input type="button" value="auth1" onclick="send_auth1()">
        <input type="button" value="auth2" onclick="send_auth2()">
        <input type="button" value="auth3" onclick="send_auth3()">
        <input type="button" value="setup" onclick="send_setup()">
        <input type="button" value="stop" onclick="send_stop()">
        <br><br>
        <input type="button" value="subs" onclick="send_subscribe()">
        <input type="button" value="subs_mnesia" onclick="send_subscribe_mnesia()">
        <input type="button" value="subs_abcdef" onclick="send_subscribe_abcdef()">
        <input type="button" value="subs_abcdef_f" onclick="send_subscribe_abcdef_f()">
        <input type="button" value="subs_abcets_f" onclick="send_subscribe_abcets_f()">
        <input type="button" value="subs_kafka" onclick="send_subscribe_kafka()">
        <br><br>
        <input type="button" value="cr_up" onclick="send_cr_up()">
        <input type="button" value="cr_cr" onclick="send_cr_cr()">
        <input type="button" value="del" onclick="send_del()">
        <br><br>
        -------------------------------------------------
        <br><br>
        cmd
        <br><br>
        <textarea name="txta" id="txta" cols="80" rows="5"></textarea>
        <input type="button" value="send" onclick="send_textarea()">
        <div id="alert"></div>
    </body>
</html>
